"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = withI18next;

require("core-js/modules/web.dom.iterable");

require("core-js/modules/es6.array.iterator");

require("core-js/modules/es6.object.keys");

var _merge2 = _interopRequireDefault(require("lodash/merge"));

var _i18next = _interopRequireDefault(require("i18next"));

var _reactI18next = require("react-i18next");

var _i18nextBrowserLanguagedetector = _interopRequireDefault(require("i18next-browser-languagedetector"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

// https://reacttraining.com/react-router/core/guides/redux-integration/deep-integration
function withI18next(_ref) {
  var _ref$i18nextConfig = _ref.i18nextConfig,
      i18nextConfig = _ref$i18nextConfig === void 0 ? {} : _ref$i18nextConfig,
      config = _objectWithoutProperties(_ref, ["i18nextConfig"]);

  /* eslint-disable import/no-named-as-default-member */
  var initClientI18n = function initClientI18n() {
    _i18next.default // .use(XHR)
    .use(_i18nextBrowserLanguagedetector.default)
    /* eslint-enable import/no-named-as-default-member */
    .init((0, _merge2.default)({
      fallbackLng: 'en',
      load: 'languageOnly',
      defaultNS: 'common',
      debug: process.env.NODE_ENV !== 'production',
      interpolation: {
        escapeValue: false // not needed for react!!

      },
      // https://github.com/i18next/i18next-browser-languageDetector
      detection: {
        caches: ['cookie', 'localStorage'],
        order: ['querystring', 'cookie', 'localStorage', 'navigator', 'htmlTag', 'path', 'subdomain'],
        cookieMinutes: 60 * 24 * 365
      } // https://github.com/i18next/i18next-xhr-backend
      // backend: {},

    }, i18nextConfig));

    return _i18next.default;
  };

  return _objectSpread({
    _enableI18next: true,
    _I18nextProvider: _reactI18next.I18nextProvider,
    _initClientI18n: initClientI18n
  }, config);
}
/* eslint-enable filenames/match-exported */


module.exports = exports.default;