import "core-js/modules/web.dom.iterable";
import _merge from "lodash/merge";

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import i18n from 'i18next';
import { I18nextProvider } from 'react-i18next'; // import XHR from 'i18next-xhr-backend';

import LanguageDetector from 'i18next-browser-languagedetector'; // https://reacttraining.com/react-router/core/guides/redux-integration/deep-integration

export default function withI18next(_ref) {
  let {
    // optional
    i18nextConfig = {}
  } = _ref,
      config = _objectWithoutProperties(_ref, ["i18nextConfig"]);

  /* eslint-disable import/no-named-as-default-member */
  const initClientI18n = () => {
    i18n // .use(XHR)
    .use(LanguageDetector)
    /* eslint-enable import/no-named-as-default-member */
    .init(_merge({
      fallbackLng: 'en',
      load: 'languageOnly',
      defaultNS: 'common',
      debug: process.env.NODE_ENV !== 'production',
      interpolation: {
        escapeValue: false // not needed for react!!

      },
      // https://github.com/i18next/i18next-browser-languageDetector
      detection: {
        caches: ['cookie', 'localStorage'],
        order: ['querystring', 'cookie', 'localStorage', 'navigator', 'htmlTag', 'path', 'subdomain'],
        cookieMinutes: 60 * 24 * 365
      } // https://github.com/i18next/i18next-xhr-backend
      // backend: {},

    }, i18nextConfig));
    return i18n;
  };

  return _objectSpread({
    _enableI18next: true,
    _I18nextProvider: I18nextProvider,
    _initClientI18n: initClientI18n
  }, config);
}
/* eslint-enable filenames/match-exported */